import SchemaForm from './components/index'

import formObject from './components/form-object'
import formArray from './components/form-array'
import formString from './components/form-string'
import formNumber from './components/form-number'
import formInteger from './components/form-integer'
import formBoolean from './components/form-boolean'
import formOneOf from './components/oneOf'
import formRef from './components/ref'
import codeMirror from './components/code-mirror'

const components = [
  SchemaForm,
  formObject,
  formArray,
  formString,
  formNumber,
  formInteger,
  formBoolean,
  formOneOf,
  formRef,
  codeMirror
]
components.forEach(component => {
  component.install = function (Vue) {
    Vue.component(component.name, component)
  }
})

export default {
  SchemaForm,
  formObject,
  formArray,
  formString,
  formNumber,
  formInteger,
  formBoolean,
  formOneOf,
  formRef,
  codeMirror
}
