import { isArray, isNumber, isUndefined, isString } from './type'

export const createObject = (path, value) => {
  let keyPath = []
  if (isArray(path)) keyPath = [...path]
  if (keyPath.length) {
    const key = keyPath.shift()
    if (isNumber(key)) {
      const object = new Array(key + 1)
      object[key] = createObject(keyPath, value)
      return object
    } else return { [key]: createObject(keyPath, value) }
  } else return value
}

export const setPathValue = (object, path, value) => {
  let keyPath = []
  if (isArray(path)) keyPath = [...path]
  if (keyPath.length) {
    const key = keyPath.shift()
    if (object && object[key]) { object[key] = setPathValue(object[key], keyPath, value) } else object[key] = createObject(keyPath, value)
  } else object = value
  return object
}

export const getPathValue = (object, path) => {
  let keyPath = []
  if (isArray(path)) keyPath = [...path]
  else if (isString(path) || isNumber(path)) keyPath = [path]
  if (keyPath.length) {
    const key = keyPath.shift()
    if (object && !isUndefined(object[key])) { return getPathValue(object[key], keyPath) } else return undefined
  } else return object
}
